/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package business.base;

import java.util.HashMap;
import java.util.LinkedHashMap;

/**
 *
 * @author balikm1
 */
public class BaseSubject implements IListItem {

    protected String name;
    protected String code;
    protected int credits;

    // <editor-fold defaultstate="collapsed" desc="Getters & Setters">

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public int getCredits() {
        return credits;
    }

    public void setCredits(int credits) {
        this.credits = credits;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
    
    // </editor-fold>

    // <editor-fold defaultstate="collapsed" desc="Object overrides">

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final BaseSubject other = (BaseSubject) obj;
        if ((this.name == null) ? (other.name != null) : !this.name.equals(other.name)) {
            return false;
        }
        if ((this.code == null) ? (other.code != null) : !this.code.equals(other.code)) {
            return false;
        }
        if (this.credits != other.credits) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 71 * hash + (this.name != null ? this.name.hashCode() : 0);
        hash = 71 * hash + (this.code != null ? this.code.hashCode() : 0);
        hash = 71 * hash + this.credits;
        return hash;
    }

    // </editor-fold>

    // <editor-fold defaultstate="collapsed" desc="IListItem methods">

    public HashMap<String, String> getPublicAttributes() {
        HashMap<String, String> map = new LinkedHashMap<String, String>();
        map.put("Název", this.name);
        map.put("Kód", this.code);
        map.put("Počet kreditů", Integer.toString(this.credits));
        return map;
    }

    public boolean hasSubitems() {
        return false;
    }

    public IList getSubitems() {
        throw new UnsupportedOperationException("Has no subitems.");
    }

    public boolean isEditable() {
        return false;
    }

    public boolean canCreate() {
        return false;
    }

    // </editor-fold>


}
