/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import business.base.IList;
import business.entities.Result;
import business.entities.Student;
import java.awt.Container;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JPanel;

/**
 *
 * @author balikm1
 */
public class ButtonPanel extends JPanel {

    IList datasource;

    public ButtonPanel(IList datasource) {
        this.datasource = datasource;
        initComponents();
        refreshButtons();
    }

    // <editor-fold defaultstate="collapsed" desc="initComponents & events">
    private void initComponents() {

        buttonPanel = new javax.swing.JPanel();
        listPanel = new ListPanel(datasource.current());

        previousButton = new javax.swing.JButton();
        nextButton = new javax.swing.JButton();

        setLayout(new java.awt.BorderLayout());

        // previous button
        previousButton.setText("Previous");
        previousButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                remove(listPanel);
                listPanel = new ListPanel(datasource.previous());
                add(listPanel);

                eventRepack(e);

            }

        });
        buttonPanel.add(previousButton);

        // next button
        nextButton.setText("Next");
        nextButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                remove(listPanel);
                listPanel = new ListPanel(datasource.next());
                add(listPanel);

                eventRepack(e);

            }

        });
        buttonPanel.add(nextButton);

        // edit button
        if (datasource.current() != null && datasource.current().isEditable())
        {
            javax.swing.JButton editButton = new javax.swing.JButton();
            editButton.setText("Edit");
            editButton.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    if (datasource.current() instanceof Student) {
                        new StudentEditor((Student)datasource.current()).setVisible(true);
                        remove(listPanel);
                        listPanel = new ListPanel(datasource.current());
                        add(listPanel);
                    } else if (datasource.current() instanceof Result) {
                        new ResultEditor((Result)datasource.current()).setVisible(true);
                        remove(listPanel);
                        listPanel = new ListPanel(datasource.current());
                        add(listPanel);
                    }

                    eventRepack(e);

                }

            });
            buttonPanel.add(editButton);
        }

        // new button
        if (datasource.current() != null && datasource.current().canCreate())
        {
            javax.swing.JButton newButton = new javax.swing.JButton();
            newButton.setText("New");
            newButton.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    if (datasource.current() instanceof Student)
                        new StudentEditor().setVisible(true);
                    else if (datasource.current() instanceof Result)
                        new ResultEditor().setVisible(true);

                    refreshButtons();
                }

            });
            buttonPanel.add(newButton);
        }


        // detail button
        if (datasource.current() != null && datasource.current().hasSubitems())
        {
            javax.swing.JButton detailButton = new javax.swing.JButton();
            detailButton.setText("Detail");
            detailButton.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    new ListDialog(datasource.current().getSubitems()).setVisible(true);
                }

            });
            buttonPanel.add(detailButton);
        }

        add(buttonPanel, java.awt.BorderLayout.PAGE_END);
        add(listPanel, java.awt.BorderLayout.CENTER);
    }
    
    // </editor-fold>

    // <editor-fold defaultstate="collapsed" desc="Helper methods">

    private void eventRepack(ActionEvent e) {
        if( e.getSource() instanceof JButton )
        {
            Container c = ((JButton)(e.getSource())).getParent();
            while( (c.getParent() != null)&&(!(c instanceof Window)) )
            {
                c = c.getParent();
            }
            if( c instanceof Window )
            {
                Window w = ( Window )c;
                w.pack();
            }
        }
        refreshButtons();
    }

    private void refreshButtons()
    {
        previousButton.setEnabled(datasource.hasPrevious());
        nextButton.setEnabled(datasource.hasNext());
    }
    
    // </editor-fold>

    // <editor-fold defaultstate="collapsed" desc="Components declaration">

    private javax.swing.JPanel buttonPanel;
    private javax.swing.JButton previousButton;
    private javax.swing.JButton nextButton;
    private ListPanel listPanel;

    // </editor-fold>

}
