/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import business.base.IHasCredit;
import business.base.IHasExam;
import business.entities.Result;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 *
 * @author balikm1
 */
public class ResultEditor extends JDialog {

    Result item;

    /** Creates new StudentEditor */
    public ResultEditor(Result datasource) {
        this.item = datasource;
        initComponents();
    }

    public ResultEditor()
    {
        this.item = null;
        initComponents();
    }

    // <editor-fold defaultstate="collapsed" desc="initComponents & events">
    private void initComponents() {

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().setLayout(new BorderLayout());

        setTitle("Editace");

        boolean credit = (item != null && item.getSubject() instanceof IHasCredit);
        boolean exam = (item != null && item.getSubject() instanceof IHasExam);
        int rows = 4;
        if (!exam && credit)
            rows = 2;
        if (credit && !exam)
            rows = 3;

        listPanel = new JPanel();
        listPanel.setLayout(new GridLayout(rows,2));
        // predmet
        rowPanel11 = new JPanel();
        rowPanel11.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));
        rowPanel12 = new JPanel();
        rowPanel12.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        lblSubject = new JLabel();
        lblSubject.setText("Předmět:");
        rowPanel11.add(lblSubject);
        listPanel.add(rowPanel11);

        txtSubject = new JTextField();
        txtSubject.setPreferredSize(new Dimension(100, 20));
        txtSubject.setEditable(false);
        if (item != null)
            txtSubject.setText(item.getSubject().getName());
        rowPanel12.add(txtSubject);
        listPanel.add(rowPanel12);

        // zapocet
        if (credit)
        {
            rowPanel21 = new JPanel();
            rowPanel21.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));
            rowPanel22 = new JPanel();
            rowPanel22.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

            lblCredit = new JLabel();
            lblCredit.setText("Zápočet:");
            rowPanel21.add(lblCredit);
            listPanel.add(rowPanel21);

            chkCredit = new JCheckBox();
            if (item != null)
                chkCredit.setSelected(item.hasCredit());
            rowPanel22.add(chkCredit);
            listPanel.add(rowPanel22);
        }

        // zkouska
        if (exam)
        {
            rowPanel31 = new JPanel();
            rowPanel31.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));
            rowPanel32 = new JPanel();
            rowPanel32.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

            lblExam = new JLabel();
            lblExam.setText("Zkouška:");
            rowPanel31.add(lblExam);
            listPanel.add(rowPanel31);

            chkExam = new JCheckBox();
            chkExam.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    rowPanel42.setVisible(chkExam.isSelected());
                }
            });
            if (item != null)
                chkExam.setSelected(item.hasExamResult());
            rowPanel32.add(chkExam);
            listPanel.add(rowPanel32);

            // znamka
            rowPanel41 = new JPanel();
            rowPanel41.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));
            rowPanel42 = new JPanel();
            rowPanel42.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

            lblGrade = new JLabel();
            lblGrade.setText("Známka:");
            rowPanel41.add(lblGrade);
            listPanel.add(rowPanel41);

            txtGrade = new JTextField();
            txtGrade.setPreferredSize(new Dimension(100, 20));
            if (item != null && item.hasExamResult()) {
                try {
                    txtGrade.setText(Integer.toString(item.getExamResult()));
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
                txtGrade.setEditable(false);
            }
            rowPanel42.add(txtGrade);
            listPanel.add(rowPanel42);
            rowPanel42.setVisible(item != null && item.hasExamResult());
        }

        // buttons
        buttonPanel = new JPanel();
        buttonPanel.setLayout(new FlowLayout());

        okButton = new JButton();
        okButton.setText("OK");
        okButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                saveItem();
            }
        });
        buttonPanel.add(okButton);

        cancelButton = new JButton();
        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                setVisible(false);
            }
        });
        buttonPanel.add(cancelButton);

        getContentPane().add(buttonPanel, java.awt.BorderLayout.SOUTH);
        getContentPane().add(listPanel, java.awt.BorderLayout.CENTER);

        this.setResizable(false);
        this.setModal(true);

        pack();
    }

    // </editor-fold>

    public void saveItem() {
        if (item != null) {
            try {
                if (item != null && item.getSubject() instanceof IHasCredit)
                    if (chkCredit.isSelected()) {
                        item.setCredit();
                    } else {
                        item.removeCredit();
                    }
                if (item != null && item.getSubject() instanceof IHasExam)
                    if (chkExam.isSelected()) {
                        item.setExamResult(Integer.parseInt(txtGrade.getText()));
                    } else {
                        item.removeExamResult();
                    }
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        setVisible(false);
    }

    // <editor-fold defaultstate="collapsed" desc="Components declaration">

    private JPanel buttonPanel = new JPanel();
    private JPanel listPanel = new JPanel();
    private JButton okButton = new JButton();
    private JButton cancelButton = new JButton();
    private JPanel rowPanel11 = new JPanel();
    private JPanel rowPanel12 = new JPanel();
    private JPanel rowPanel21 = new JPanel();
    private JPanel rowPanel22 = new JPanel();
    private JPanel rowPanel31 = new JPanel();
    private JPanel rowPanel32 = new JPanel();
    private JPanel rowPanel41 = new JPanel();
    private JPanel rowPanel42 = new JPanel();
    private JLabel lblSubject = new JLabel();
    private JLabel lblCredit = new JLabel();
    private JLabel lblExam = new JLabel();
    private JLabel lblGrade = new JLabel();
    private JTextField txtSubject = new JTextField();
    private JCheckBox chkCredit = new JCheckBox();
    private JCheckBox chkExam = new JCheckBox();
    private JTextField txtGrade = new JTextField();

    // </editor-fold>

}
